

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//	bcd_decode_u64, bcd_encode_u64 i bcd_mul z formu elektroda.pl	//
//http://www.elektroda.pl/rtvforum/viewtopic.php?p=16171465#16171465//
//																	//
//******************************************************************//


#include <rmik/bcd.h>


//=======================================================================//
uint64_t bcd_decode_u64(uint64_t bcd)
{
uint64_t n = 0;
uint64_t mul = 1;


	while (bcd)
		{
		n += (bcd & 0xf) * mul;
		bcd >>= 4;
		mul *= 10;
		}

	return n;
}


//----------------------------------------------------------------------//
uint64_t bcd_encode_u64(uint64_t n)
{
uint64_t bcd = 0;
int shift = 0;


	while (n)
		{
		bcd |= (n % 10) << shift;
		n /= 10;
		shift += 4;
		}
	return bcd;
}


//----------------------------------------------------------------------//
uint64_t bcd_add_u64(uint64_t bcda, uint64_t bcdb, byte *overflow)
{
uint64_t a = bcd_decode_u64(bcda);
uint64_t b = bcd_decode_u64(bcdb);

	uint64_t acc = a + b;

	if (overflow)
		{
		*overflow = (!((acc / a) == b)) || (acc > 9999999999999999ull);
		}

	return bcd_encode_u64(acc);
}


//----------------------------------------------------------------------//
uint64_t bcd_sub_u64(uint64_t bcda, uint64_t bcdb, byte *znak)
{
uint64_t a = bcd_decode_u64(bcda);
uint64_t b = bcd_decode_u64(bcdb);
uint64_t acc;
byte c=0;


	if ( a>b ) acc = a - b;
	else { acc = b - a; c = -1; }

	if (znak)
		{
		*znak = c;
		}

	return bcd_encode_u64(acc);
}


//----------------------------------------------------------------------//
uint64_t bcd_mul_u64(uint64_t bcda, uint64_t bcdb, byte *overflow)
{
uint64_t a = bcd_decode_u64(bcda);
uint64_t b = bcd_decode_u64(bcdb);

	uint64_t acc = a * b;

	if (overflow)
		{
		*overflow = (!((acc / a) == b)) || (acc > 9999999999999999ull);
		}

	return bcd_encode_u64(acc);
}


//----------------------------------------------------------------------//
uint64_t bcd_div_u64(uint64_t bcda, uint64_t bcdb, uint64_t *reszta)
{
uint64_t a = bcd_decode_u64(bcda);
uint64_t b = bcd_decode_u64(bcdb);

	uint64_t acc = a / b;

	if (reszta)
		{
		*reszta = bcd_encode_u64(a % b);
		}

	return bcd_encode_u64(acc);
}


//=======================================================================//
byte u08_bcd2bin( byte bcd )
{
	return( ((bcd >> 4) * 10) | (bcd & 0xF) );
}


//----------------------------------------------------------------------//
byte u08_bin2bcd( byte bin )
{
	return( ((bin / 10) << 4) | bin % 10 );
}


//=======================================================================//
/*
byte inline bcd4add( byte *dest, byte src )
{
u08 c=0;


	*dest &= 0xF; src &= 0xF;							// Zostawiamy tylko modsze bajty
	*dest += src;										// Dodajemy
	if ( *dest>9 ) { c++; *dest += 6; *dest &= 0xF; }	// Jeli > 9

	return( c );
}


//----------------------------------------------------------------------//
byte bcd8add( byte *dest, byte src )
{
u08 c=0, lo, hi;


	lo = *dest;
	hi = *dest >> 4;
	if ( bcd4add( &lo, src ) ) hi++;

	c=bcd4add( &hi, src >> 4 );
	*dest = (hi << 4) + lo;

	return( c );
}


//----------------------------------------------------------------------//
byte bcd16add( u16 *dest, u16 src )
{
u08 c=0, lo, hi;


	lo = *dest;
	hi = *dest >> 8;
	if ( bcd8add( &lo, src ) ) hi++;

	c = bcd8add( &hi, src >> 8 );
	*dest = (u16)(hi << 8) + lo;

	return( c );
}


//----------------------------------------------------------------------//
byte bcd32add( u32 *dest, u32 src )
{
u08 c=0;
u16 lo, hi;


	lo = *dest;
	hi = *dest >> 16;
	if ( bcd16add( &lo, src ) ) hi++;

	c = bcd16add( &hi, src >> 16 );
	*dest = ((u32)hi << 16) + lo;

	return( c );
}


//----------------------------------------------------------------------//
byte bcd64add( u64 *dest, u64 src )
{
u08 c=0;
u32 lo, hi;


	lo = *dest;
	hi = *dest >> 32;
	if ( bcd32add( &lo, src ) ) hi++;

	c = bcd32add( &hi, src >> 32 );
	*dest = ((u64)hi << 32) + lo;


	return( c );
}


*/


