

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


#ifndef DS2431_H_
#define	DS2431_H_


/*
			STD			OVERDRIVE
tRSTL		480..640	48..80		czas resetu
tPDH		15..60		2..6		slot testu bitu obecnoci

tSLOT		61...		8...		czas okna bitu
tW0L		60..120		6..16		zapis bitu 0
tW1L		1..15		1..2		zapis bitu 1

tRL			5..15		1..2		strob odczytu
tMSR		tRL + 15	tRL + 2		okno odczytu wartoci bitu

*/


//=======================================================================//
//DS2431
#define ONEWIRE_2431_writeSCRATCHPAD	0x0F
#define ONEWIRE_2431_readSCRATCHPAD		0xAA
#define ONEWIRE_2431_readMEMORY	 		0xF0
#define ONEWIRE_2431_copySCRATCHPAD		0x55


byte ds2431_wr( byte skip, byte *match, byte *src, word Ta );
byte ds2431_protect( byte skip, byte *match, byte protect, word TA );
void ds2431wr_EMU( word _TA );


extern byte ds2431_read( byte skip, byte *match, byte *dst, word TA, byte len );
extern byte ds2431_write( byte skip, byte *match, byte *src, word TA );
extern byte ds2431_user( byte skip, byte *match, byte userL, byte userH );
extern byte ds2431_protectEPROM( byte skip, byte *match, byte protect, word TA );
extern byte ds2431_protectROM( byte skip, byte *match, byte protect, word TA );
extern byte ds2431_protectGLOBAL( byte skip, byte *match, byte protect, word TA );


//=======================================================================//
#endif


