#warning "test multimaster"
//jeden TWI gada normalnie z DS2482, drugi (uruchamiany) odczytuje status z DS2482
// moe art na ten temat?

#warning "rozkazy read/write block"
// xxxBlock( ADR_IIC, *buf, LEN)
// zwraca liczb danych odebranych lub wysanych
//w funkcjach jeli len>2 to:
// lij bajty
// ostatni bez ACK
//jeli len==1 to:
// wylijj/odczytaj jeden bajt bez ACK



byte TWI_Status=-1;


extern void TWI_Master_Initialise();
extern byte TWI_Action( byte command );
extern byte TWI_Start();
extern byte TWI_Stop();
#define	TWI_Exit	TWI_Stop
extern byte TWI_Write( byte d );
extern byte TWI_Read( byte ack );


#warning "dodac funkcje send adresW i R"


//======================================================================//
void TWI_Master_Initialise()
{
	//SCL frequency CPU Clock frequency / ( 16 + 2(TWBR) + 4  TWPS ) TWPS = PRESKALER
	//F_CPU/(16+2*TWBR+4*(TWSR&3))
	// TWBR min 10
	TWBR = ((F_CPU/1000/TWISCK)-16)/2;
	#if (((F_CPU/1000/TWISCK)-16)/2) < 10
	  #error "Podobno sieje bledy"
	  #warning "Podobno sieje bledy"
//	if ( TWBR < 10 ) TWBR=10;
	#endif

// TWSR = TWI_TWPS;		// Not used. Driver presumes prescaler to be 00.
//	TWDR = 0xFF;			// Default content = SDA released.
	TWCR = (1<<TWEN);		// Enable TWI-interface and release TWI pins.
}


//----------------------------------------------------------------------//
byte TWI_Action( byte command )
{
byte overtime=100;


	//write command to TWCR and make sure TWINT is set
	TWCR = (command | (1<<TWINT) | (1<<TWEN) );
	//now wait for TWINT to be set again (when the operation is completed)
	while( !(TWCR & (1<<TWINT)) )
		{
		_delay_us(10);
		overtime--;
		if ( !overtime ) break;
		}
/*
There are two status codes that do not correspond to a defined TWI state, see Table
120.
Status 0xF8 indicates that no relevant information is available because the TWINT Flag
is not set. This occurs between other states, and when the TWI is not involved in a serial
transfer.
Status 0x00 indicates that a bus error has occurred during a 2-wire Serial Bus transfer.
A bus error occurs when a START or STOP condition occurs at an illegal position in the
format frame. Examples of such illegal positions are during the serial transfer of an
address byte, a data byte, or an acknowledge bit. When a bus error occurs, TWINT is
set. To recover from a bus error, the TWSTO Flag must set and TWINT must be cleared
by writing a logic one to it. This causes the TWI to enter the not addressed Slave mode
and to clear the TWSTO Flag (no other bits in TWCR are affected). The SDA and SCL
lines are released, and no STOP condition is transmitted.
*/
/*
Istniej dwa kody stanu, ktre nie odpowiadaj okrelonym stanie TWI, patrz tabela 120.

Stan 0xF8 wskazuje, e adne istotne informacje s dostpne poniewa TWINT Flag
nie jest ustawiona. Dzieje si tak gdy TWI nie jest zaangarzowany w transfer.
Jeli status F8 pojawia si po wysaniu warunku statt, moe to oznacza uszkodzenie magistrali IIC (zwarcie lub brak rezystorw podcigajcych).

Stan 0x00 oznacza, e wystpi bd magistrali IIC.
Bd wystpuje, gdy START lub STOP pojawi si w nieodpowiednim miejscu najczciej podczas nielegalnego przejcia magistrali.
Gdy wystpi bd magistrali (w trybie Slave), naley wyserowa TWSTO i ustawiC TWINT.
TWI nie wygeneruje nic na magistrali ale zwolni linie.
*/
	TWI_Status = TWSR & 0b11111100;
	return( TWI_Status );
}


//----------------------------------------------------------------------//
byte TWI_Stop()
{
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	// Generujc stop czekamy na bit TWSTO a nie WTINT
	while ( (TWCR & (1<<TWSTO)) );

	return( TWSR );
}


//----------------------------------------------------------------------//
byte TWI_StatusTransceiver_Busy()
{
	return ( TWCR & (1<<TWIE) );		// IF TWI Interrupt is enabled then the Transceiver is busy
}


//----------------------------------------------------------------------//
byte TWI_Start()
{
	return( TWI_Action( 1<<TWSTA ) );
}


//----------------------------------------------------------------------//
byte TWI_Read( byte ack )
{
	if ( ack ) TWI_Action( 1<<TWEA );
	else TWI_Action( 0 );

	TWI_Status = TWSR;
	return( TWDR );
}


//----------------------------------------------------------------------//
byte TWI_Write( byte d )
{
	TWDR = d;
	return( TWI_Action( 0 ) );
}


//======================================================================//
